=== debian/control ===
Source: openzwave
Maintainer: Lucas Nussbaum <lucas@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>=9), dh-exec (>=0.2), g++ (>= 4.4), libudev-dev, libxml2-utils
Standards-Version: 3.9.6
Homepage: http://www.openzwave.com/

Package: libopenzwave1.3
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API to use a Z-Wave controller
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains the library.

Package: libopenzwave1.3-dev
Section: libdevel
Depends: ${misc:Depends}, libopenzwave1.3 (= ${binary:Version})
Architecture: any
Description: header files for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains files for developing.

Package: libopenzwave-doc
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Architecture: all
Description: documentation for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains documentation.

Package: openzwave
Section: misc
Architecture: any
Depends: libopenzwave1.3 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends} 
Description: Sample Program for libopenzwave 
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
